---
title: Create Sign-On Policy Action (PROGRESSIVE_PROFILING)
description: The POST {{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions operation creates a new sign-on policy action resource. The priority property specifies the order in which this action (and its conditions) is evaluated when evaluating the policy. Property values range from 1 to {maxInt}. The action with a priority value of 1 is evaluated first.
component: pingone-api
page_id: pingone-api:platform:sign-on-policies/sign-on-policy-actions/create-sign-on-policy-action-progressive_profiling
canonical_url: https://developer.pingidentity.com/pingone-api/platform/sign-on-policies/sign-on-policy-actions/create-sign-on-policy-action-progressive_profiling.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create Sign-On Policy Action (PROGRESSIVE\_PROFILING)

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions
```

The `POST {{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions` operation creates a new sign-on policy action resource. The `priority` property specifies the order in which this action (and its conditions) is evaluated when evaluating the policy. Property values range from `1` to `{maxInt}`. The action with a `priority` value of `1` is evaluated first.

|   |                                                                                                                                                                                                                                                                               |
| - | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|   | The `condition` property for the sign-on policy action specifies the conditions associated with the action. At least one condition must be met to execute the action. If the `conditions` attribute is omitted from the sign-on policy action, the action is always executed. |

The sample shows the request for a `PROGRESSIVE_PROFILING` action type.

|   |                                                                                                                                                                         |
| - | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|   | If all attributes configured for the progressive profiling action are defined as optional (`"required": false`), users can skip this action in the authentication flow. |

### Prerequisites

* [Sign-on Policy Actions](../sign-on-policy-actions.html)

* [Create a sign-on policy](../sign-on-policies-1/create-sign-on-policy.html) to get a `policyID` for the endpoint.

* [Create a population](../../populations/create-population.html) to get a `popID` for the body. Refer also to [Populations](../../populations.html).

> **Collapse: Request Model**
>
> | Property                        | Type    | Required? |
> | ------------------------------- | ------- | --------- |
> | `attributes.name`               | String  | Required  |
> | `attributes.required`           | Boolean | Required  |
> | `preventMultiplePromptsPerFlow` | Boolean | Required  |
> | `priority`                      | Integer | Required  |
> | `promptIntervalSeconds`         | Integer | Required  |
> | `promptText`                    | String  | Required  |
> | `type`                          | String  | Required  |
>
> Refer to the [Sign-on policy actions base data model](../sign-on-policy-actions.html#sign-on-policy-actions-base-data-model) for full property descriptions.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "priority": 40,
    "type": "PROGRESSIVE_PROFILING",
    "condition": {
        "or": [
            {
                "value": "${user.population.id}",
                "equals": "{{popID}}"
            },
            {
                "value": "${user.type}",
                "equals": "Customer"
            }
        ]
    },
    "promptText": "For the best experience, we need a couple things from you.",
    "promptIntervalSeconds": 3600,
    "preventMultiplePromptsPerFlow": false,
    "attributes": [
        {
            "name": "address.postalCode",
            "required": false
        }
    ]
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "priority": 40,
    "type": "PROGRESSIVE_PROFILING",
    "condition": {
        "or": [
            {
                "value": "${user.population.id}",
                "equals": "{{popID}}"
            },
            {
                "value": "${user.type}",
                "equals": "Customer"
            }
        ]
    },
    "promptText": "For the best experience, we need a couple things from you.",
    "promptIntervalSeconds": 3600,
    "preventMultiplePromptsPerFlow": false,
    "attributes": [
        {
            "name": "address.postalCode",
            "required": false
        }
    ]
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""priority"": 40," + "\n" +
@"    ""type"": ""PROGRESSIVE_PROFILING""," + "\n" +
@"    ""condition"": {" + "\n" +
@"        ""or"": [" + "\n" +
@"            {" + "\n" +
@"                ""value"": ""${user.population.id}""," + "\n" +
@"                ""equals"": ""{{popID}}""" + "\n" +
@"            }," + "\n" +
@"            {" + "\n" +
@"                ""value"": ""${user.type}""," + "\n" +
@"                ""equals"": ""Customer""" + "\n" +
@"            }" + "\n" +
@"        ]" + "\n" +
@"    }," + "\n" +
@"    ""promptText"": ""For the best experience, we need a couple things from you.""," + "\n" +
@"    ""promptIntervalSeconds"": 3600," + "\n" +
@"    ""preventMultiplePromptsPerFlow"": false," + "\n" +
@"    ""attributes"": [" + "\n" +
@"        {" + "\n" +
@"            ""name"": ""address.postalCode""," + "\n" +
@"            ""required"": false" + "\n" +
@"        }" + "\n" +
@"    ]" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions"
  method := "POST"

  payload := strings.NewReader(`{
    "priority": 40,
    "type": "PROGRESSIVE_PROFILING",
    "condition": {
        "or": [
            {
                "value": "${user.population.id}",
                "equals": "{{popID}}"
            },
            {
                "value": "${user.type}",
                "equals": "Customer"
            }
        ]
    },
    "promptText": "For the best experience, we need a couple things from you.",
    "promptIntervalSeconds": 3600,
    "preventMultiplePromptsPerFlow": false,
    "attributes": [
        {
            "name": "address.postalCode",
            "required": false
        }
    ]
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "priority": 40,
    "type": "PROGRESSIVE_PROFILING",
    "condition": {
        "or": [
            {
                "value": "${user.population.id}",
                "equals": "{{popID}}"
            },
            {
                "value": "${user.type}",
                "equals": "Customer"
            }
        ]
    },
    "promptText": "For the best experience, we need a couple things from you.",
    "promptIntervalSeconds": 3600,
    "preventMultiplePromptsPerFlow": false,
    "attributes": [
        {
            "name": "address.postalCode",
            "required": false
        }
    ]
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"priority\": 40,\n    \"type\": \"PROGRESSIVE_PROFILING\",\n    \"condition\": {\n        \"or\": [\n            {\n                \"value\": \"${user.population.id}\",\n                \"equals\": \"{{popID}}\"\n            },\n            {\n                \"value\": \"${user.type}\",\n                \"equals\": \"Customer\"\n            }\n        ]\n    },\n    \"promptText\": \"For the best experience, we need a couple things from you.\",\n    \"promptIntervalSeconds\": 3600,\n    \"preventMultiplePromptsPerFlow\": false,\n    \"attributes\": [\n        {\n            \"name\": \"address.postalCode\",\n            \"required\": false\n        }\n    ]\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "priority": 40,
    "type": "PROGRESSIVE_PROFILING",
    "condition": {
      "or": [
        {
          "value": "${user.population.id}",
          "equals": "{{popID}}"
        },
        {
          "value": "${user.type}",
          "equals": "Customer"
        }
      ]
    },
    "promptText": "For the best experience, we need a couple things from you.",
    "promptIntervalSeconds": 3600,
    "preventMultiplePromptsPerFlow": false,
    "attributes": [
      {
        "name": "address.postalCode",
        "required": false
      }
    ]
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "priority": 40,
    "type": "PROGRESSIVE_PROFILING",
    "condition": {
      "or": [
        {
          "value": "${user.population.id}",
          "equals": "{{popID}}"
        },
        {
          "value": "${user.type}",
          "equals": "Customer"
        }
      ]
    },
    "promptText": "For the best experience, we need a couple things from you.",
    "promptIntervalSeconds": 3600,
    "preventMultiplePromptsPerFlow": false,
    "attributes": [
      {
        "name": "address.postalCode",
        "required": false
      }
    ]
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions"

payload = json.dumps({
  "priority": 40,
  "type": "PROGRESSIVE_PROFILING",
  "condition": {
    "or": [
      {
        "value": "${user.population.id}",
        "equals": "{{popID}}"
      },
      {
        "value": "${user.type}",
        "equals": "Customer"
      }
    ]
  },
  "promptText": "For the best experience, we need a couple things from you.",
  "promptIntervalSeconds": 3600,
  "preventMultiplePromptsPerFlow": False,
  "attributes": [
    {
      "name": "address.postalCode",
      "required": False
    }
  ]
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "priority": 40,\n    "type": "PROGRESSIVE_PROFILING",\n    "condition": {\n        "or": [\n            {\n                "value": "${user.population.id}",\n                "equals": "{{popID}}"\n            },\n            {\n                "value": "${user.type}",\n                "equals": "Customer"\n            }\n        ]\n    },\n    "promptText": "For the best experience, we need a couple things from you.",\n    "promptIntervalSeconds": 3600,\n    "preventMultiplePromptsPerFlow": false,\n    "attributes": [\n        {\n            "name": "address.postalCode",\n            "required": false\n        }\n    ]\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "priority": 40,
  "type": "PROGRESSIVE_PROFILING",
  "condition": {
    "or": [
      {
        "value": "\${user.population.id}",
        "equals": "{{popID}}"
      },
      {
        "value": "\${user.type}",
        "equals": "Customer"
      }
    ]
  },
  "promptText": "For the best experience, we need a couple things from you.",
  "promptIntervalSeconds": 3600,
  "preventMultiplePromptsPerFlow": false,
  "attributes": [
    {
      "name": "address.postalCode",
      "required": false
    }
  ]
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"priority\": 40,\n    \"type\": \"PROGRESSIVE_PROFILING\",\n    \"condition\": {\n        \"or\": [\n            {\n                \"value\": \"${user.population.id}\",\n                \"equals\": \"{{popID}}\"\n            },\n            {\n                \"value\": \"${user.type}\",\n                \"equals\": \"Customer\"\n            }\n        ]\n    },\n    \"promptText\": \"For the best experience, we need a couple things from you.\",\n    \"promptIntervalSeconds\": 3600,\n    \"preventMultiplePromptsPerFlow\": false,\n    \"attributes\": [\n        {\n            \"name\": \"address.postalCode\",\n            \"required\": false\n        }\n    ]\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/signOnPolicies/{{policyID}}/actions")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/signOnPolicies/f73594d5-9b2e-45bf-abec-3f629ab53721/actions/3ede2d1f-0006-4206-85f8-8efd2dc4bdb2"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "signOnPolicy": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/signOnPolicies/f73594d5-9b2e-45bf-abec-3f629ab53721"
        }
    },
    "id": "3ede2d1f-0006-4206-85f8-8efd2dc4bdb2",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "type": "PROGRESSIVE_PROFILING",
    "condition": {
        "or": [
            {
                "value": "${user.population.id}",
                "equals": "cb3ef0a0-0ff5-4f60-ae82-4ae65d9d0e3a"
            },
            {
                "value": "${user.type}",
                "equals": "Customer"
            }
        ]
    },
    "signOnPolicy": {
        "id": "f73594d5-9b2e-45bf-abec-3f629ab53721"
    },
    "priority": 40,
    "attributes": [
        {
            "name": "address.postalCode",
            "required": false
        }
    ],
    "preventMultiplePromptsPerFlow": false,
    "promptText": "For the best experience, we need a couple things from you.",
    "promptIntervalSeconds": 3600
}
```
